/***************************************************************************
                          dbcommand.cpp  -  description
                             -------------------
    begin                : Sun Jan 2 2000
    copyright            : (C) 2000 by Jon Anderson
    email                : janderson@onelink.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dbcommand.h"

DBCommand::DBCommand(Entity *_e, int _command)
{
	command = _command;
	e = _e;
}
DBCommand::~DBCommand()
{

}

bool DBCommand::execute()
{
    switch(command){
  	case CLEAR:
	  	return false;
  		break;
  	case ADD:
    	ObjectDB::getInstance()->add( e );
    	return true;
  		break;
  	case REMOVE:
	  	ObjectDB::getInstance()->remove( e );  	
	  	return true;
  		break;
  	default:
  		return false;
  		break;
  }
}

bool DBCommand::undo()
{
    switch(command){
  	case CLEAR:
	  	return false;
  		break;
  	case ADD:
	  	ObjectDB::getInstance()->remove(e);
	  	return true;
  		break;
  	case REMOVE:
    	ObjectDB::getInstance()->add(e);
    	return true;		
  		break;
  	default:
  		return false;
  		break;
  }
}
